export interface Permission {
  mode: string;
  uid: string;
  scope: string;
  method: string;
  address: string;
}
export interface Options {
  scopes: string;
  appID: string;
  space: string;
  type: string;
  url?: string;
  apps?:string;
  unsecure?: boolean;
  connected?: boolean;
}
export interface ServerData {
  sender: string;
  token: string;
  data: any;
  date: any;
  body?:any;
  send?: Function;
}
export interface QueryType {
  scope: string;
  address: string;
  method: string;
}
export interface Cloudstorage {
  Keys: Map<string, string>;
  setItem: Function;
  getItem: Function;
}
export interface ExecuteType {
  scope: string;
  uniqueID?: string;
  TokenID?: string;
  address: string;
  info: {
    method: string;
    gateway_id?: string,
    app_id?: string,
    uid?: string,
    response?: Boolean,
    msg_id?: string;
    plugin?: string;
    data: any;
    cache?:{
      ttl:number,
      delete?:boolean,
      update?:boolean
    }

  };
}
export interface CallType {
  scope: string;
  user?: string;
  token?: string;
  app?:string;
  address: string;
  method: string;
  data: any;
}

export interface Service {
  uid:string;
  name:string;
  loadbalance?:boolean;
  weight:number;
}
export interface QueryCallback {
  (ServerData: ServerData, Query: QueryType): void;
}
